var Store = require('../../store');

exports.definition = {
  mixinCallback: function(){
    var self = this;
    
    this.onFind(function(query, data, next){
      query.exec(function(err, resp) {

        self.logger.info(query.toString());
        
        if(err) data.error = new Store.SQLError(err);
        data.result = resp;
        
        next();
        
      });
    });
  }
}


/*
 * MODEL
 */
exports.model = {
  
  getExecOptions: function(){
    return this.query;
  },
  
  
  toSql: function(){
    var sql;
    var query = this.query;
        
    //make async?
    this.callInterceptors('beforeFind', [query], function(){
      sql = query.toString();
    });
    
    return sql.replace(/`/g, '\"').replace(/'(\d+)'/g, '$1');
  }
  
};